-- ---------------------------------------------------------------------------------
-- 
-- Converts the Xpert.ivy system database from version 32 to version 33
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- ivyTeam AG, Alpenstrasse 9, 6304 Zug
-- ---------------------------------------------------------------------------------

IF EXISTS (
   SELECT 'X'
   FROM sysindexes
   WHERE id = (SELECT OBJECT_ID('IWA_ContentManagementSystem'))
   AND name = 'IWA_ContentManagementSystem_AppIdIndex'
) 
BEGIN
DROP INDEX IWA_ContentManagementSystem.IWA_ContentManagementSystem_AppIdIndex;
CREATE INDEX IWA_ContentManagementSystem_ApplicationIdIndex ON IWA_ContentManagementSystem(ApplicationId);
END

GO
IF EXISTS (
   SELECT 'X'
   FROM sysindexes
   WHERE id = (SELECT OBJECT_ID('IWA_IntermediateEvent'))
   AND name = 'IWA_IntermediateEvent_AppId'
) 
BEGIN
DROP INDEX IWA_IntermediateEvent.IWA_IntermediateEvent_AppId;
CREATE INDEX IWA_IntermediateEvent_ApplicationId ON IWA_IntermediateEvent(ApplicationId);
END

GO
IF EXISTS (
   SELECT 'X'
   FROM sysindexes
   WHERE id = (SELECT OBJECT_ID('IWA_ContentManagementSystem'))
   AND name = 'IWA_ContentManagementSystem_ProcessModelVersionIdIndex'
) 
BEGIN
DROP INDEX IWA_ContentManagementSystem.IWA_ContentManagementSystem_ProcessModelVersionIdIndex;
CREATE INDEX IWA_ContentManagementSystem_ProcessModelVersionId ON IWA_ContentManagementSystem(ProcessModelVersionId);
END

GO
-- Drop views which depend on changed tables
DROP VIEW IWA_TaskQuery
GO

DROP VIEW IWA_ProcessStart
GO

-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_ForeignKey
@tableName varchar(100),
@columnName varchar(100)
AS
DECLARE @fkName Varchar(255)
SET @fkName= (
  SELECT fk.name
  FROM sys.foreign_keys fk
  INNER JOIN sys.foreign_key_columns fkc ON fkc.constraint_object_id = fk.object_id
  INNER JOIN sys.columns c1 ON fkc.parent_column_id = c1.column_id AND fkc.parent_object_id = c1.object_id
  INNER JOIN sys.columns c2 ON fkc.referenced_column_id = c2.column_id AND fkc.referenced_object_id = c2.object_id
  WHERE OBJECT_NAME(fk.parent_object_id)=@tableName AND c2.name=@columnName
)
DECLARE @dropSql varchar(4000)
SET @dropSql=
  'ALTER TABLE [dbo].['+@tableName+']
    DROP CONSTRAINT ['+@fkName+']'
EXEC(@dropSql)

GO

EXECUTE IWA_Drop_ForeignKey @tableName='IWA_BusinessCalendar', @columnName='ApplicationId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_Library', @columnName='ApplicationId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_Environment', @columnName='BusinessCalendarId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_Case', @columnName='BusinessCalendarId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_Task', @columnName='BusinessCalendarId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_Library', @columnName='ProcessModelVersionId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_LibrarySpecification', @columnName='LibraryId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_LibraryVersionSpec', @columnName='LibrarySpecificationId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_WebServiceProcStartElement', @columnName='WebServiceProcessId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_AsyncProcessCaseData', @columnName='CaseId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogData', @columnName='EventLogId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogTaskHistory', @columnName='EventLogId'
GO
EXECUTE IWA_Drop_ForeignKey @tableName='IWA_EventLogStatus', @columnName='EventLogId'
GO
-- Store Procedure to drop a primary key constraint
CREATE PROCEDURE IWA_Drop_PrimaryKey
@tableName varchar(100)
AS
DECLARE @pkName Varchar(255)
SET @pkName= (
  SELECT [name] FROM sysobjects
    WHERE [xtype] = 'PK'
          AND [parent_obj] = OBJECT_ID(N'[dbo].['+@tableName+N']')
)
DECLARE @dropSql varchar(4000)
SET @dropSql=
  'ALTER TABLE [dbo].['+@tableName+']
    DROP CONSTRAINT ['+@PkName+']'
EXEC(@dropSql)

GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_AsyncProcessCaseData'
GO

-- Changed columns of table IWA_AsyncProcessCaseData
ALTER TABLE IWA_AsyncProcessCaseData ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_AsyncProcessCaseData ADD PRIMARY KEY (CaseId, EventId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ClusterNode'
GO

-- Changed columns of table IWA_ClusterNode
ALTER TABLE IWA_ClusterNode ALTER COLUMN ClusterNodeId BIGINT NOT NULL
GO
ALTER TABLE IWA_ClusterNode ALTER COLUMN MasterClusterNodeId BIGINT NULL
GO
ALTER TABLE IWA_ClusterNode ADD PRIMARY KEY (ClusterNodeId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_Unique
@tablename varchar(100)
AS
DECLARE @parentid integer
DECLARE @uqname varchar(100)
DECLARE table_cursor CURSOR FOR SELECT id FROM sysobjects WHERE name = @tablename
OPEN  table_cursor
FETCH NEXT FROM table_cursor INTO @parentid
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR ('TABLE %s not found in table sysobjects', 16, 1, @tablename)
  CLOSE table_cursor
  DEALLOCATE table_cursor
  RETURN
END
DECLARE uq_cursor CURSOR FOR
SELECT name from sysobjects WHERE parent_obj = @parentid AND xtype = 'UQ'
CLOSE table_cursor
DEALLOCATE table_cursor
OPEN uq_cursor
FETCH NEXT FROM uq_cursor INTO @uqname
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR('Unique constraint of table %s not found in table sysobjects', 16, 1, @tablename);
  CLOSE uq_cursor
  DEALLOCATE uq_cursor
  RETURN
END
WHILE @@FETCH_STATUS=0
BEGIN
  EXEC('ALTER TABLE '+@tablename+' DROP CONSTRAINT '+@uqname)
  FETCH NEXT FROM uq_cursor INTO @uqname
END
CLOSE uq_cursor
DEALLOCATE uq_cursor
GO

EXECUTE IWA_Drop_Unique 'IWA_ClusterNodeProperty'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ClusterNodeProperty'
GO

-- Changed columns of table IWA_ClusterNodeProperty
ALTER TABLE IWA_ClusterNodeProperty ALTER COLUMN ClusterNodePropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_ClusterNodeProperty ALTER COLUMN ClusterNodeId BIGINT NOT NULL
GO
ALTER TABLE IWA_ClusterNodeProperty ADD PRIMARY KEY (ClusterNodePropertyId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ClusterNodeProperty ADD UNIQUE (ClusterNodeId, PropertyName)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Application'
GO
DECLARE @defname VARCHAR(100), @cmd VARCHAR(1000)
SET @defname = 
(SELECT name
FROM sysobjects so JOIN sysconstraints sc
ON so.id = sc.constid
WHERE object_name(so.parent_obj) = 'IWA_Application'
AND so.xtype = 'D'
AND sc.colid =
 (SELECT colid FROM syscolumns
 WHERE id = object_id('dbo.IWA_Application') AND
 name = 'SecurityDescriptorId'))
SET @cmd = 'ALTER TABLE IWA_Application DROP CONSTRAINT '
+ @defname
EXEC(@cmd)

GO

-- Changed columns of table IWA_Application
ALTER TABLE IWA_Application ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Application ALTER COLUMN SystemUserId BIGINT NULL
GO
ALTER TABLE IWA_Application ALTER COLUMN SecurityDescriptorId BIGINT NULL
GO
ALTER TABLE IWA_Application ALTER COLUMN BusinessCalendarId BIGINT NULL
GO
ALTER TABLE IWA_Application ADD CONSTRAINT DEFIWA_ApplicationSecurityDescriptorId  DEFAULT NULL FOR SecurityDescriptorId
GO
ALTER TABLE IWA_Application ADD PRIMARY KEY (ApplicationId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ApplicationProperty'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ApplicationProperty'
GO

-- Changed columns of table IWA_ApplicationProperty
ALTER TABLE IWA_ApplicationProperty ALTER COLUMN ApplicationPropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_ApplicationProperty ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_ApplicationProperty ADD PRIMARY KEY (ApplicationPropertyId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ApplicationProperty ADD UNIQUE (ApplicationId, PropertyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_Environment'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Environment'
GO

-- Changed columns of table IWA_Environment
ALTER TABLE IWA_Environment ALTER COLUMN EnvironmentId BIGINT NOT NULL
GO
ALTER TABLE IWA_Environment ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Environment ALTER COLUMN BusinessCalendarId BIGINT NULL
GO
ALTER TABLE IWA_Environment ADD PRIMARY KEY (EnvironmentId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_Environment ADD UNIQUE (ApplicationId, Name)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_GlobalVariable'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_GlobalVariable'
GO

-- Changed columns of table IWA_GlobalVariable
ALTER TABLE IWA_GlobalVariable ALTER COLUMN GlobalVariableId BIGINT NOT NULL
GO
ALTER TABLE IWA_GlobalVariable ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_GlobalVariable ALTER COLUMN ParentGlobalVariableId BIGINT NULL
GO
ALTER TABLE IWA_GlobalVariable ALTER COLUMN EnvironmentId BIGINT NULL
GO
ALTER TABLE IWA_GlobalVariable ADD PRIMARY KEY (GlobalVariableId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_GlobalVariable ADD UNIQUE (ApplicationId, EnvironmentId, Name)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_WebService'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebService'
GO

-- Changed columns of table IWA_WebService
ALTER TABLE IWA_WebService ALTER COLUMN WebServiceId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebService ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebService ADD PRIMARY KEY (WebServiceId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_WebService ADD UNIQUE (ApplicationId, GenerationIdentifier)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebServiceEnvironment'
GO

-- Changed columns of table IWA_WebServiceEnvironment
ALTER TABLE IWA_WebServiceEnvironment ALTER COLUMN WebServiceEnvironmentId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEnvironment ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEnvironment ALTER COLUMN WebServiceId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEnvironment ALTER COLUMN EnvironmentId BIGINT NULL
GO
ALTER TABLE IWA_WebServiceEnvironment ADD PRIMARY KEY (WebServiceEnvironmentId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_WebServicePortType'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebServicePortType'
GO

-- Changed columns of table IWA_WebServicePortType
ALTER TABLE IWA_WebServicePortType ALTER COLUMN WebServicePortTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServicePortType ALTER COLUMN WebServiceId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServicePortType ADD PRIMARY KEY (WebServicePortTypeId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_WebServicePortType ADD UNIQUE (WebServiceId, PortType)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebServiceEndpoint'
GO

-- Changed columns of table IWA_WebServiceEndpoint
ALTER TABLE IWA_WebServiceEndpoint ALTER COLUMN WebServiceEndpointId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEndpoint ALTER COLUMN WebServiceEnvironmentId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEndpoint ALTER COLUMN WebServicePortTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceEndpoint ADD PRIMARY KEY (WebServiceEndpointId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_BusinessCalendar'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_BusinessCalendar'
GO

-- Changed columns of table IWA_BusinessCalendar
ALTER TABLE IWA_BusinessCalendar ALTER COLUMN BusinessCalendarId BIGINT NOT NULL
GO
ALTER TABLE IWA_BusinessCalendar ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_BusinessCalendar ALTER COLUMN ParentCalendarId BIGINT NULL
GO
ALTER TABLE IWA_BusinessCalendar ADD PRIMARY KEY (BusinessCalendarId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_BusinessCalendar ADD UNIQUE (ApplicationId, Name)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ExternalNamingAndDirectory'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ExternalNamingAndDirectory'
GO

-- Changed columns of table IWA_ExternalNamingAndDirectory
ALTER TABLE IWA_ExternalNamingAndDirectory ALTER COLUMN ExternalNamingAndDirectoryId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalNamingAndDirectory ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalNamingAndDirectory ADD PRIMARY KEY (ExternalNamingAndDirectoryId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ExternalNamingAndDirectory ADD UNIQUE (ApplicationId, UserFriendlyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ExternalDatabase'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ExternalDatabase'
GO

-- Changed columns of table IWA_ExternalDatabase
ALTER TABLE IWA_ExternalDatabase ALTER COLUMN ExternalDatabaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalDatabase ALTER COLUMN ParentExternalDatabaseId BIGINT NULL
GO
ALTER TABLE IWA_ExternalDatabase ALTER COLUMN EnvironmentId BIGINT NULL
GO
ALTER TABLE IWA_ExternalDatabase ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalDatabase ADD PRIMARY KEY (ExternalDatabaseId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ExternalDatabase ADD UNIQUE (ApplicationId, ParentExternalDatabaseId, EnvironmentId, UserFriendlyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ExternalDatabaseProperty'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ExternalDatabaseProperty'
GO

-- Changed columns of table IWA_ExternalDatabaseProperty
ALTER TABLE IWA_ExternalDatabaseProperty ALTER COLUMN ExternalDatabaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalDatabaseProperty ALTER COLUMN ExternalDatabasePropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_ExternalDatabaseProperty ADD PRIMARY KEY (ExternalDatabasePropertyId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ExternalDatabaseProperty ADD UNIQUE (ExternalDatabaseId, PropertyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ProcessModel'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ProcessModel'
GO

-- Changed columns of table IWA_ProcessModel
ALTER TABLE IWA_ProcessModel ALTER COLUMN ProcessModelId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModel ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModel ADD PRIMARY KEY (ProcessModelId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ProcessModel ADD UNIQUE (ApplicationId, Name)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ProcessModelVersion'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ProcessModelVersion'
GO

-- Changed columns of table IWA_ProcessModelVersion
ALTER TABLE IWA_ProcessModelVersion ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModelVersion ALTER COLUMN ProcessModelId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModelVersion ADD PRIMARY KEY (ProcessModelVersionId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ProcessModelVersion ADD UNIQUE (ProcessModelId, VersionNumber)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_Library'
GO
select null
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Library'
GO

-- Changed columns of table IWA_Library
ALTER TABLE IWA_Library ALTER COLUMN LibraryId BIGINT NOT NULL
GO
ALTER TABLE IWA_Library ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_Library ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Library ADD PRIMARY KEY (LibraryId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_Library ADD UNIQUE (ApplicationId, Id, Version)
GO
ALTER TABLE IWA_Library ADD UNIQUE (ProcessModelVersionId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_LibrarySpecification'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_LibrarySpecification'
GO

-- Changed columns of table IWA_LibrarySpecification
ALTER TABLE IWA_LibrarySpecification ALTER COLUMN LibrarySpecificationId BIGINT NOT NULL
GO
ALTER TABLE IWA_LibrarySpecification ALTER COLUMN LibraryId BIGINT NOT NULL
GO
ALTER TABLE IWA_LibrarySpecification ALTER COLUMN ResolvedLibraryId BIGINT NULL
GO
ALTER TABLE IWA_LibrarySpecification ADD PRIMARY KEY (LibrarySpecificationId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_LibrarySpecification ADD UNIQUE (LibraryId, Id)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_LibraryVersionSpec'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_LibraryVersionSpec'
GO

-- Changed columns of table IWA_LibraryVersionSpec
ALTER TABLE IWA_LibraryVersionSpec ALTER COLUMN LibraryVersionSpecId BIGINT NOT NULL
GO
ALTER TABLE IWA_LibraryVersionSpec ALTER COLUMN LibrarySpecificationId BIGINT NOT NULL
GO
ALTER TABLE IWA_LibraryVersionSpec ADD PRIMARY KEY (LibraryVersionSpecId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_LibraryVersionSpec ADD UNIQUE (LibrarySpecificationId, Minimum)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_PageElement'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_PageElement'
GO

-- Changed columns of table IWA_PageElement
ALTER TABLE IWA_PageElement ALTER COLUMN PageElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_PageElement ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_PageElement ADD PRIMARY KEY (PageElementId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_PageElement ADD UNIQUE (ProcessModelVersionId, PID)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ProcessModelVersionRole'
GO

-- Changed columns of table IWA_ProcessModelVersionRole
ALTER TABLE IWA_ProcessModelVersionRole ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModelVersionRole ALTER COLUMN RoleId BIGINT NOT NULL
GO
ALTER TABLE IWA_ProcessModelVersionRole ADD PRIMARY KEY (ProcessModelVersionId, RoleId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_Role'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Role'
GO

-- Changed columns of table IWA_Role
ALTER TABLE IWA_Role ALTER COLUMN RoleId BIGINT NOT NULL
GO
ALTER TABLE IWA_Role ALTER COLUMN ParentRoleId BIGINT NULL
GO
ALTER TABLE IWA_Role ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Role ADD PRIMARY KEY (RoleId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_Role ADD UNIQUE (ApplicationId, Name)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_RoleProperty'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_RoleProperty'
GO

-- Changed columns of table IWA_RoleProperty
ALTER TABLE IWA_RoleProperty ALTER COLUMN RoleId BIGINT NOT NULL
GO
ALTER TABLE IWA_RoleProperty ALTER COLUMN RolePropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_RoleProperty ADD PRIMARY KEY (RolePropertyId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_RoleProperty ADD UNIQUE (RoleId, PropertyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_User'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_User'
GO

-- Changed columns of table IWA_User
ALTER TABLE IWA_User ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_User ALTER COLUMN EMailLanguageId BIGINT NULL
GO
ALTER TABLE IWA_User ALTER COLUMN ApplicationId BIGINT NOT NULL
GO

-- Added columns of table IWA_User
ALTER TABLE IWA_User ADD
  "State" INTEGER NOT NULL DEFAULT 0
GO
ALTER TABLE IWA_User ADD PRIMARY KEY (UserId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_User ADD UNIQUE (ApplicationId, Name)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_UserRole'
GO

-- Changed columns of table IWA_UserRole
ALTER TABLE IWA_UserRole ALTER COLUMN RoleId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserRole ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserRole ADD PRIMARY KEY (RoleId, UserId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_UserProperty'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_UserProperty'
GO

-- Changed columns of table IWA_UserProperty
ALTER TABLE IWA_UserProperty ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserProperty ALTER COLUMN UserPropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserProperty ADD PRIMARY KEY (UserPropertyId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_UserProperty ADD UNIQUE (UserId, PropertyName)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_RichDialogUserContext'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_RichDialogUserContext'
GO

-- Changed columns of table IWA_RichDialogUserContext
ALTER TABLE IWA_RichDialogUserContext ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_RichDialogUserContext ALTER COLUMN RichDialogUserContextId BIGINT NOT NULL
GO
ALTER TABLE IWA_RichDialogUserContext ADD PRIMARY KEY (RichDialogUserContextId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_RichDialogUserContext ADD UNIQUE (UserId, ComponentName, ContextName)
GO


-- Drop indexes which depend on changed columns
DROP INDEX IWA_UserAbsence.IWA_UserAbsence_UserIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_UserAbsence'
GO

-- Changed columns of table IWA_UserAbsence
ALTER TABLE IWA_UserAbsence ALTER COLUMN UserAbsenceId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserAbsence ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserAbsence ADD PRIMARY KEY (UserAbsenceId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_UserAbsence_UserIdIndex ON IWA_UserAbsence(UserId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_UserSubstitute'
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_UserSubstitute.IWA_UserSubstitute_UserIdIndex
GO
DROP INDEX IWA_UserSubstitute.IWA_UserSubstitute_SubstituteUserIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_UserSubstitute'
GO

-- Changed columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ALTER COLUMN UserSubstituteId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserSubstitute ALTER COLUMN UserId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SubstituteUserId BIGINT NOT NULL
GO
ALTER TABLE IWA_UserSubstitute ALTER COLUMN SubstituteForRoleId BIGINT NULL
GO
ALTER TABLE IWA_UserSubstitute ADD PRIMARY KEY (UserSubstituteId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_UserSubstitute_UserIdIndex ON IWA_UserSubstitute(UserId)
GO
CREATE INDEX IWA_UserSubstitute_SubstituteUserIdIndex ON IWA_UserSubstitute(SubstituteUserId)
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_UserSubstitute ADD UNIQUE (UserId, SubstituteUserId, SubstituteForRoleId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_TaskElement'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskElement'
GO

-- Changed columns of table IWA_TaskElement
ALTER TABLE IWA_TaskElement ALTER COLUMN TaskElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskElement ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskElement ADD PRIMARY KEY (TaskElementId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_TaskElement ADD UNIQUE (ProcessModelVersionId, ProcessElementId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_TaskStart'
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskStart'
GO

-- Changed columns of table IWA_TaskStart
ALTER TABLE IWA_TaskStart ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskStart ALTER COLUMN TaskElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskStart ADD PRIMARY KEY (TaskStartId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_TaskStart ADD UNIQUE (TaskElementId, StartRequestPath)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_TaskEnd'
GO
select null
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskEnd'
GO

-- Changed columns of table IWA_TaskEnd
ALTER TABLE IWA_TaskEnd ALTER COLUMN TaskEndId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskEnd ALTER COLUMN TaskElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskEnd ADD PRIMARY KEY (TaskEndId)
GO
-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_TaskEnd ADD UNIQUE (TaskElementId, JoinRequestPath)
GO
ALTER TABLE IWA_TaskEnd ADD UNIQUE (TaskElementId, JoinPathId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskSwitchEvent'
GO

-- Changed columns of table IWA_TaskSwitchEvent
ALTER TABLE IWA_TaskSwitchEvent ALTER COLUMN TaskSwitchEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskSwitchEvent ALTER COLUMN TaskElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskSwitchEvent ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskSwitchEvent ADD PRIMARY KEY (TaskSwitchEventId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_StartElement'
GO

-- Changed columns of table IWA_StartElement
ALTER TABLE IWA_StartElement ALTER COLUMN ActivatorRoleId BIGINT NULL
GO
ALTER TABLE IWA_StartElement ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_StartElement ALTER COLUMN ActivatorUserId BIGINT NULL
GO
ALTER TABLE IWA_StartElement ADD PRIMARY KEY (TaskStartId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_StartEventElement'
GO

-- Changed columns of table IWA_StartEventElement
ALTER TABLE IWA_StartEventElement ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_StartEventElement ALTER COLUMN ActivatorRoleId BIGINT NULL
GO
ALTER TABLE IWA_StartEventElement ADD PRIMARY KEY (TaskStartId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebServiceProcess'
GO

-- Changed columns of table IWA_WebServiceProcess
ALTER TABLE IWA_WebServiceProcess ALTER COLUMN WebServiceProcessId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceProcess ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceProcess ADD PRIMARY KEY (WebServiceProcessId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WebServiceProcStartElement'
GO

-- Changed columns of table IWA_WebServiceProcStartElement
ALTER TABLE IWA_WebServiceProcStartElement ALTER COLUMN ActivatorRoleId BIGINT NULL
GO
ALTER TABLE IWA_WebServiceProcStartElement ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceProcStartElement ALTER COLUMN WebServiceProcessId BIGINT NOT NULL
GO
ALTER TABLE IWA_WebServiceProcStartElement ADD PRIMARY KEY (TaskStartId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_IntermediateEventElement'
GO

-- Changed columns of table IWA_IntermediateEventElement
ALTER TABLE IWA_IntermediateEventElement ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_IntermediateEventElement ADD PRIMARY KEY (TaskStartId)
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_Case.IWA_Case_ApplicationIdIndex
GO
DROP INDEX IWA_Case.IWA_Case_ApplicationIdCreationTimestampStateIndex
GO
DROP INDEX IWA_Case.IWA_Case_ProcessModelIdIndex
GO
DROP INDEX IWA_Case.IWA_Case_TaskStartIdIndex
GO
DROP INDEX IWA_Case.IWA_Case_CreatorUserIdIndex
GO
DROP INDEX IWA_Case.IWA_Case_CreatorTaskIdIndex
GO
DROP INDEX IWA_Case.IWA_Case_WorkingTime
GO
DROP INDEX IWA_Case.IWA_Case_BusinessRuntime
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Case'
GO

-- Changed columns of table IWA_Case
ALTER TABLE IWA_Case ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN ProcessModelId BIGINT NOT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN CreatorUserId BIGINT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN CreatorTaskId BIGINT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN EnvironmentId BIGINT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN BusinessCalendarId BIGINT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN WorkingTime BIGINT NULL
GO
ALTER TABLE IWA_Case ALTER COLUMN BusinessRuntime BIGINT NULL
GO
ALTER TABLE IWA_Case ADD PRIMARY KEY (CaseId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_Case_ApplicationIdIndex ON IWA_Case(ApplicationId)
GO
CREATE INDEX IWA_Case_ApplicationIdCreationTimestampStateIndex ON IWA_Case(ApplicationId, StartTimestamp, "State")
GO
CREATE INDEX IWA_Case_ProcessModelIdIndex ON IWA_Case(ProcessModelId)
GO
CREATE INDEX IWA_Case_TaskStartIdIndex ON IWA_Case(TaskStartId)
GO
CREATE INDEX IWA_Case_CreatorUserIdIndex ON IWA_Case(CreatorUserId)
GO
CREATE INDEX IWA_Case_CreatorTaskIdIndex ON IWA_Case(CreatorTaskId)
GO
CREATE INDEX IWA_Case_WorkingTime ON IWA_Case(WorkingTime)
GO
CREATE INDEX IWA_Case_BusinessRuntime ON IWA_Case(BusinessRuntime)
GO


-- Drop indexes which depend on changed columns
DROP INDEX IWA_Task.IWA_Task_CaseIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ApplicationIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ProcessModelIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_WorkerUserIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ActivatorRoleIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ActivatorUserIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ExpiryActivatorRoleIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_ExpiryActivatorUserIdIndex
GO
DROP INDEX IWA_Task.IWA_Task_WorkingTime
GO
DROP INDEX IWA_Task.IWA_Task_BusinessRuntime
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Task'
GO

-- Changed columns of table IWA_Task
ALTER TABLE IWA_Task ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ProcessModelId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN StartTaskSwitchEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN EndTaskSwitchEventId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN TaskEndId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN WorkerUserId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ActivatorRoleId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ActivatorUserId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ExpiryActivatorRoleId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ExpiryActivatorUserId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN ExpiredCreatorTaskId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN TimeoutedCreatorIntrmdtEventId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN BusinessCalendarId BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN WorkingTime BIGINT NULL
GO
ALTER TABLE IWA_Task ALTER COLUMN BusinessRuntime BIGINT NULL
GO
ALTER TABLE IWA_Task ADD PRIMARY KEY (TaskId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_Task_CaseIdIndex ON IWA_Task(CaseId)
GO
CREATE INDEX IWA_Task_ApplicationIdIndex ON IWA_Task(ApplicationId)
GO
CREATE INDEX IWA_Task_ProcessModelIdIndex ON IWA_Task(ProcessModelId)
GO
CREATE INDEX IWA_Task_WorkerUserIdIndex ON IWA_Task(WorkerUserId)
GO
CREATE INDEX IWA_Task_ActivatorRoleIdIndex ON IWA_Task(ActivatorRoleId)
GO
CREATE INDEX IWA_Task_ActivatorUserIdIndex ON IWA_Task(ActivatorUserId)
GO
CREATE INDEX IWA_Task_ExpiryActivatorRoleIdIndex ON IWA_Task(ExpiryActivatorRoleId)
GO
CREATE INDEX IWA_Task_ExpiryActivatorUserIdIndex ON IWA_Task(ExpiryActivatorUserId)
GO
CREATE INDEX IWA_Task_WorkingTime ON IWA_Task(WorkingTime)
GO
CREATE INDEX IWA_Task_BusinessRuntime ON IWA_Task(BusinessRuntime)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskData'
GO

-- Changed columns of table IWA_TaskData
ALTER TABLE IWA_TaskData ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskData ADD PRIMARY KEY (TaskId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_StartTaskData'
GO

-- Changed columns of table IWA_StartTaskData
ALTER TABLE IWA_StartTaskData ALTER COLUMN TaskSwitchEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_StartTaskData ADD PRIMARY KEY (TaskSwitchEventId)
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_WorkflowEvent.IWA_WorkflowEvent_ApplicationIdIndex
GO
DROP INDEX IWA_WorkflowEvent.IWA_WorkflowEvent_CaseIdIndex
GO
DROP INDEX IWA_WorkflowEvent.IWA_WorkflowEvent_TaskIdIndex
GO
DROP INDEX IWA_WorkflowEvent.IWA_WorkflowEvent_UserIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_WorkflowEvent'
GO

-- Changed columns of table IWA_WorkflowEvent
ALTER TABLE IWA_WorkflowEvent ALTER COLUMN WorkflowEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_WorkflowEvent ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_WorkflowEvent ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_WorkflowEvent ALTER COLUMN TaskId BIGINT NULL
GO
ALTER TABLE IWA_WorkflowEvent ALTER COLUMN UserId BIGINT NULL
GO
ALTER TABLE IWA_WorkflowEvent ADD PRIMARY KEY (WorkflowEventId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_WorkflowEvent_ApplicationIdIndex ON IWA_WorkflowEvent(ApplicationId)
GO
CREATE INDEX IWA_WorkflowEvent_CaseIdIndex ON IWA_WorkflowEvent(CaseId)
GO
CREATE INDEX IWA_WorkflowEvent_TaskIdIndex ON IWA_WorkflowEvent(TaskId)
GO
CREATE INDEX IWA_WorkflowEvent_UserIdIndex ON IWA_WorkflowEvent(UserId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_IntermediateEvent'
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_IntermediateEvent.IWA_IntrmdtEvnt_TaskStartId
GO
DROP INDEX IWA_IntermediateEvent.IWA_IntermediateEvent_ApplicationId
GO
DROP INDEX IWA_IntermediateEvent.IWA_IntermediateEvent_TaskId
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_IntermediateEvent'
GO

-- Changed columns of table IWA_IntermediateEvent
ALTER TABLE IWA_IntermediateEvent ALTER COLUMN IntermediateEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_IntermediateEvent ALTER COLUMN TaskStartId BIGINT NOT NULL
GO
ALTER TABLE IWA_IntermediateEvent ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_IntermediateEvent ALTER COLUMN TaskId BIGINT NULL
GO
ALTER TABLE IWA_IntermediateEvent ADD PRIMARY KEY (IntermediateEventId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_IntrmdtEvnt_TaskStartId ON IWA_IntermediateEvent(TaskStartId)
GO
CREATE INDEX IWA_IntermediateEvent_ApplicationId ON IWA_IntermediateEvent(ApplicationId)
GO
CREATE INDEX IWA_IntermediateEvent_TaskId ON IWA_IntermediateEvent(TaskId)
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_IntermediateEvent ADD UNIQUE (TaskStartId, EventId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_IntermediateEventData'
GO

-- Changed columns of table IWA_IntermediateEventData
ALTER TABLE IWA_IntermediateEventData ALTER COLUMN IntermediateEventId BIGINT NOT NULL
GO
ALTER TABLE IWA_IntermediateEventData ADD PRIMARY KEY (IntermediateEventId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_EventLog'
GO

-- Changed columns of table IWA_EventLog
ALTER TABLE IWA_EventLog ALTER COLUMN EventLogId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLog ADD PRIMARY KEY (EventLogId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_EventLogData'
GO

-- Changed columns of table IWA_EventLogData
ALTER TABLE IWA_EventLogData ALTER COLUMN EventLogId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogData ADD PRIMARY KEY (EventLogId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_EventLogTaskHistory'
GO

-- Changed columns of table IWA_EventLogTaskHistory
ALTER TABLE IWA_EventLogTaskHistory ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogTaskHistory ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogTaskHistory ALTER COLUMN EventLogId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogTaskHistory ADD PRIMARY KEY (EventLogId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_EventLogCaseHistory'
GO

-- Changed columns of table IWA_EventLogCaseHistory
ALTER TABLE IWA_EventLogCaseHistory ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogCaseHistory ADD PRIMARY KEY (CaseId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_EventLogStatus'
GO

-- Changed columns of table IWA_EventLogStatus
ALTER TABLE IWA_EventLogStatus ALTER COLUMN EventLogId BIGINT NOT NULL
GO
ALTER TABLE IWA_EventLogStatus ADD PRIMARY KEY (EventLogId)
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_Note.IWA_Note_UserIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Note'
GO

-- Changed columns of table IWA_Note
ALTER TABLE IWA_Note ALTER COLUMN NoteId BIGINT NOT NULL
GO
ALTER TABLE IWA_Note ALTER COLUMN UserId BIGINT NULL
GO
ALTER TABLE IWA_Note ADD PRIMARY KEY (NoteId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_Note_UserIdIndex ON IWA_Note(UserId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskNote'
GO

-- Changed columns of table IWA_TaskNote
ALTER TABLE IWA_TaskNote ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskNote ALTER COLUMN NoteId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskNote ADD PRIMARY KEY (TaskId, NoteId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_CaseNote'
GO

-- Changed columns of table IWA_CaseNote
ALTER TABLE IWA_CaseNote ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_CaseNote ALTER COLUMN NoteId BIGINT NOT NULL
GO
ALTER TABLE IWA_CaseNote ADD PRIMARY KEY (CaseId, NoteId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_AdditionalProperty'
GO

-- Changed columns of table IWA_AdditionalProperty
ALTER TABLE IWA_AdditionalProperty ALTER COLUMN AdditionalPropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_AdditionalProperty ADD PRIMARY KEY (AdditionalPropertyId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_TaskAdditionalProperty'
GO

-- Changed columns of table IWA_TaskAdditionalProperty
ALTER TABLE IWA_TaskAdditionalProperty ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskAdditionalProperty ALTER COLUMN AdditionalPropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_TaskAdditionalProperty ADD PRIMARY KEY (TaskId, AdditionalPropertyId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_CaseAdditionalProperty'
GO

-- Changed columns of table IWA_CaseAdditionalProperty
ALTER TABLE IWA_CaseAdditionalProperty ALTER COLUMN CaseId BIGINT NOT NULL
GO
ALTER TABLE IWA_CaseAdditionalProperty ALTER COLUMN AdditionalPropertyId BIGINT NOT NULL
GO
ALTER TABLE IWA_CaseAdditionalProperty ADD PRIMARY KEY (CaseId, AdditionalPropertyId)
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_PageArchive.IWA_PageArchive_UserIdIndex
GO
DROP INDEX IWA_PageArchive.IWA_PageArchive_TaskIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_PageArchive'
GO

-- Changed columns of table IWA_PageArchive
ALTER TABLE IWA_PageArchive ALTER COLUMN PageArchiveId BIGINT NOT NULL
GO
ALTER TABLE IWA_PageArchive ALTER COLUMN UserId BIGINT NULL
GO
ALTER TABLE IWA_PageArchive ALTER COLUMN PageElementId BIGINT NOT NULL
GO
ALTER TABLE IWA_PageArchive ALTER COLUMN TaskId BIGINT NOT NULL
GO
ALTER TABLE IWA_PageArchive ADD PRIMARY KEY (PageArchiveId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_PageArchive_UserIdIndex ON IWA_PageArchive(UserId)
GO
CREATE INDEX IWA_PageArchive_TaskIdIndex ON IWA_PageArchive(TaskId)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ContentManagementSystem'
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_ContentManagementSystem.IWA_ContentManagementSystem_ApplicationIdIndex
GO
DROP INDEX IWA_ContentManagementSystem.IWA_ContentManagementSystem_ProcessModelVersionId
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentManagementSystem'
GO

-- Changed columns of table IWA_ContentManagementSystem
ALTER TABLE IWA_ContentManagementSystem ALTER COLUMN ContentManagementSystemId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentManagementSystem ALTER COLUMN ApplicationId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentManagementSystem ALTER COLUMN ProcessModelVersionId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentManagementSystem ALTER COLUMN DefaultPageLayoutId BIGINT NULL
GO
ALTER TABLE IWA_ContentManagementSystem ALTER COLUMN DefaultPageStyleSheetId BIGINT NULL
GO
ALTER TABLE IWA_ContentManagementSystem ADD PRIMARY KEY (ContentManagementSystemId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_ContentManagementSystem_ApplicationIdIndex ON IWA_ContentManagementSystem(ApplicationId)
GO
CREATE INDEX IWA_ContentManagementSystem_ProcessModelVersionId ON IWA_ContentManagementSystem(ProcessModelVersionId)
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ContentManagementSystem ADD UNIQUE (Name, ProcessModelVersionId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Language'
GO

-- Changed columns of table IWA_Language
ALTER TABLE IWA_Language ALTER COLUMN LanguageId BIGINT NOT NULL
GO
ALTER TABLE IWA_Language ADD PRIMARY KEY (LanguageId)
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_SupportedLanguage.IWA_SupportedLanguage_ContentManagementSystemIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_SupportedLanguage'
GO

-- Changed columns of table IWA_SupportedLanguage
ALTER TABLE IWA_SupportedLanguage ALTER COLUMN SupportedLanguageId BIGINT NOT NULL
GO
ALTER TABLE IWA_SupportedLanguage ALTER COLUMN ContentManagementSystemId BIGINT NOT NULL
GO
ALTER TABLE IWA_SupportedLanguage ADD PRIMARY KEY (SupportedLanguageId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_SupportedLanguage_ContentManagementSystemIdIndex ON IWA_SupportedLanguage(ContentManagementSystemId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentObjectType'
GO

-- Changed columns of table IWA_ContentObjectType
ALTER TABLE IWA_ContentObjectType ALTER COLUMN ContentObjectTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObjectType ADD PRIMARY KEY (ContentObjectTypeId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_ContentObject'
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_ContentObject.IWA_ContentObject_ParentContentObjectIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentObject'
GO

-- Changed columns of table IWA_ContentObject
ALTER TABLE IWA_ContentObject ALTER COLUMN ContentObjectId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObject ALTER COLUMN ParentContentObjectId BIGINT NULL
GO
ALTER TABLE IWA_ContentObject ALTER COLUMN ContentObjectTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObject ALTER COLUMN ContentManagementSystemId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObject ADD PRIMARY KEY (ContentObjectId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_ContentObject_ParentContentObjectIdIndex ON IWA_ContentObject(ParentContentObjectId)
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_ContentObject ADD UNIQUE (ContentManagementSystemId, Uri)
GO


-- Drop indexes which depend on changed columns
DROP INDEX IWA_StartPage.IWA_StartPage_ContentManagementSystemIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_StartPage'
GO

-- Changed columns of table IWA_StartPage
ALTER TABLE IWA_StartPage ALTER COLUMN StartPageId BIGINT NOT NULL
GO
ALTER TABLE IWA_StartPage ALTER COLUMN ContentObjectId BIGINT NULL
GO
ALTER TABLE IWA_StartPage ALTER COLUMN ContentManagementSystemId BIGINT NOT NULL
GO
ALTER TABLE IWA_StartPage ADD PRIMARY KEY (StartPageId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_StartPage_ContentManagementSystemIdIndex ON IWA_StartPage(ContentManagementSystemId)
GO


-- Drop indexes which depend on changed columns
DROP INDEX IWA_ContentObjectValue.IWA_ContentObjectValue_ContentObjectIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentObjectValue'
GO

-- Changed columns of table IWA_ContentObjectValue
ALTER TABLE IWA_ContentObjectValue ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObjectValue ALTER COLUMN ContentObjectId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentObjectValue ADD PRIMARY KEY (ContentObjectValueId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_ContentObjectValue_ContentObjectIdIndex ON IWA_ContentObjectValue(ContentObjectId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataString'
GO

-- Changed columns of table IWA_ContentDataString
ALTER TABLE IWA_ContentDataString ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataString ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataInteger'
GO

-- Changed columns of table IWA_ContentDataInteger
ALTER TABLE IWA_ContentDataInteger ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataInteger ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataFloat'
GO

-- Changed columns of table IWA_ContentDataFloat
ALTER TABLE IWA_ContentDataFloat ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataFloat ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataDateTime'
GO

-- Changed columns of table IWA_ContentDataDateTime
ALTER TABLE IWA_ContentDataDateTime ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataDateTime ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataText'
GO

-- Changed columns of table IWA_ContentDataText
ALTER TABLE IWA_ContentDataText ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataText ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataImage'
GO

-- Changed columns of table IWA_ContentDataImage
ALTER TABLE IWA_ContentDataImage ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataImage ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_ContentDataDecimal'
GO

-- Changed columns of table IWA_ContentDataDecimal
ALTER TABLE IWA_ContentDataDecimal ALTER COLUMN ContentObjectValueId BIGINT NOT NULL
GO
ALTER TABLE IWA_ContentDataDecimal ADD PRIMARY KEY (ContentObjectValueId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_SecurityDescriptor'
GO

-- Changed columns of table IWA_SecurityDescriptor
ALTER TABLE IWA_SecurityDescriptor ALTER COLUMN SecurityDescriptorId BIGINT NOT NULL
GO
ALTER TABLE IWA_SecurityDescriptor ALTER COLUMN SecurityDescriptorTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_SecurityDescriptor ALTER COLUMN OwnerUserId BIGINT NULL
GO
ALTER TABLE IWA_SecurityDescriptor ADD PRIMARY KEY (SecurityDescriptorId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_PermissionGroup'
GO

-- Changed columns of table IWA_PermissionGroup
ALTER TABLE IWA_PermissionGroup ALTER COLUMN PermissionGroupId BIGINT NOT NULL
GO
ALTER TABLE IWA_PermissionGroup ALTER COLUMN ParentPermissionGroupId BIGINT NULL
GO
ALTER TABLE IWA_PermissionGroup ADD PRIMARY KEY (PermissionGroupId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_SecurityDescriptorType'
GO

-- Changed columns of table IWA_SecurityDescriptorType
ALTER TABLE IWA_SecurityDescriptorType ALTER COLUMN SecurityDescriptorTypeId BIGINT NOT NULL
GO
ALTER TABLE IWA_SecurityDescriptorType ALTER COLUMN RootPermissionGroupId BIGINT NOT NULL
GO
ALTER TABLE IWA_SecurityDescriptorType ADD PRIMARY KEY (SecurityDescriptorTypeId)
GO

-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_AccessControl'
GO

-- Drop indexes which depend on changed columns
DROP INDEX IWA_AccessControl.IWA_AccessControl_SecurityDescriptorIdIndex
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_AccessControl'
GO

-- Changed columns of table IWA_AccessControl
ALTER TABLE IWA_AccessControl ALTER COLUMN AccessControlId BIGINT NOT NULL
GO
ALTER TABLE IWA_AccessControl ALTER COLUMN SecurityDescriptorId BIGINT NOT NULL
GO
ALTER TABLE IWA_AccessControl ALTER COLUMN PermissionId BIGINT NOT NULL
GO
ALTER TABLE IWA_AccessControl ALTER COLUMN RoleId BIGINT NULL
GO
ALTER TABLE IWA_AccessControl ALTER COLUMN UserId BIGINT NULL
GO
ALTER TABLE IWA_AccessControl ADD PRIMARY KEY (AccessControlId)
GO
-- Create index which depend on changed columns
CREATE INDEX IWA_AccessControl_SecurityDescriptorIdIndex ON IWA_AccessControl(SecurityDescriptorId)
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_AccessControl ADD UNIQUE (SecurityDescriptorId, PermissionId, RoleId, UserId)
GO

EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_Permission'
GO

-- Changed columns of table IWA_Permission
ALTER TABLE IWA_Permission ALTER COLUMN PermissionId BIGINT NOT NULL
GO
ALTER TABLE IWA_Permission ADD PRIMARY KEY (PermissionId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_PermissionGroupPermission'
GO

-- Changed columns of table IWA_PermissionGroupPermission
ALTER TABLE IWA_PermissionGroupPermission ALTER COLUMN PermissionGroupId BIGINT NOT NULL
GO
ALTER TABLE IWA_PermissionGroupPermission ALTER COLUMN PermissionId BIGINT NOT NULL
GO
ALTER TABLE IWA_PermissionGroupPermission ADD PRIMARY KEY (PermissionGroupId, PermissionId)
GO
EXECUTE IWA_Drop_PrimaryKey @tableName='IWA_UploadedFile'
GO

-- Changed columns of table IWA_UploadedFile
ALTER TABLE IWA_UploadedFile ALTER COLUMN FileId BIGINT NOT NULL
GO
ALTER TABLE IWA_UploadedFile ADD PRIMARY KEY (FileId)
GO
ALTER TABLE IWA_BusinessCalendar ADD FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
GO

ALTER TABLE IWA_Library ADD FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE
GO

ALTER TABLE IWA_Environment ADD FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
GO

ALTER TABLE IWA_Case ADD FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
GO

ALTER TABLE IWA_Task ADD FOREIGN KEY (BusinessCalendarId) REFERENCES IWA_BusinessCalendar(BusinessCalendarId) ON DELETE SET NULL
GO

ALTER TABLE IWA_Library ADD FOREIGN KEY (ProcessModelVersionId) REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE
GO

ALTER TABLE IWA_LibrarySpecification ADD FOREIGN KEY (LibraryId) REFERENCES IWA_Library(LibraryId) ON DELETE CASCADE
GO

ALTER TABLE IWA_LibraryVersionSpec ADD FOREIGN KEY (LibrarySpecificationId) REFERENCES IWA_LibrarySpecification(LibrarySpecificationId) ON DELETE CASCADE
GO

ALTER TABLE IWA_WebServiceProcStartElement ADD FOREIGN KEY (WebServiceProcessId) REFERENCES IWA_WebServiceProcess(WebServiceProcessId) ON DELETE CASCADE
GO

ALTER TABLE IWA_AsyncProcessCaseData ADD FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE
GO

ALTER TABLE IWA_EventLogData ADD FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
GO

ALTER TABLE IWA_EventLogTaskHistory ADD FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
GO

ALTER TABLE IWA_EventLogStatus ADD FOREIGN KEY (EventLogId) REFERENCES IWA_EventLog(EventLogId) ON DELETE CASCADE
GO


-- Recreate views which depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task, IWA_Case
  WHERE IWA_Task.CaseId = IWA_Case.CaseId
GO

CREATE VIEW IWA_ProcessStart
(
  TaskElementId,
  ProcessModelVersionId,
  Name,
  Description,
  ProcessElementId,
  TaskStartId,
  StartRequestPath,
  UserFriendlyStartRequestPath,
  ActivatorRoleId
)
AS
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_StartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_StartEventElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_StartEventElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_StartEventElement.TaskStartId
UNION ALL
  SELECT
    IWA_TaskElement.TaskElementId,
    IWA_TaskElement.ProcessModelVersionId,
    IWA_TaskElement.Name,
    IWA_TaskElement.Description,
    IWA_TaskElement.ProcessElementId,
    IWA_TaskStart.TaskStartId,
    IWA_TaskStart.StartRequestPath,
    IWA_TaskStart.UserFriendlyStartRequestPath,
    IWA_WebServiceProcStartElement.ActivatorRoleId
  FROM IWA_TaskElement, IWA_TaskStart, IWA_WebServiceProcStartElement
  WHERE IWA_TaskElement.TaskElementId = IWA_TaskStart.TaskElementId AND IWA_TaskStart.TaskStartId = IWA_WebServiceProcStartElement.TaskStartId
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO

ALTER TABLE IWA_Identifier ALTER COLUMN IdentifierValue BIGINT NOT NULL
GO

-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey
GO
DROP PROCEDURE IWA_Drop_PrimaryKey
GO
DROP PROCEDURE IWA_Drop_Unique
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=33
GO
