-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 37 to version 38
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_RestClient
(
  RestClientId BIGINT NOT NULL,
  UUID VARCHAR(36) NOT NULL,
  ApplicationId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  URI VARCHAR(1024) NULL,
  PRIMARY KEY (RestClientId)
)
GO

CREATE TABLE IWA_RestClientProperty
(
  RestClientPropertyId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(1024) NOT NULL,
  IsPassword BIT NOT NULL,
  PRIMARY KEY (RestClientPropertyId)
)
GO

CREATE TABLE IWA_RestClientFeature
(
  RestClientFeatureId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId)
)
GO


-- Create trigger which depend on new added table
CREATE TRIGGER IWA_RestClientDeleteTrigger
  ON IWA_RestClient FOR DELETE AS

  DELETE IWA_RestClientProperty FROM IWA_RestClientProperty, deleted
  WHERE IWA_RestClientProperty.RestClientId = deleted.RestClientId

  DELETE IWA_RestClientFeature FROM IWA_RestClientFeature, deleted
  WHERE IWA_RestClientFeature.RestClientId = deleted.RestClientId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_ApplicationProperty FROM IWA_ApplicationProperty, deleted
  WHERE IWA_ApplicationProperty.ApplicationId = deleted.ApplicationId

  DELETE IWA_Environment FROM IWA_Environment, deleted
  WHERE IWA_Environment.ApplicationId = deleted.ApplicationId

  DELETE IWA_GlobalVariable FROM IWA_GlobalVariable, deleted
  WHERE IWA_GlobalVariable.ApplicationId = deleted.ApplicationId

  DELETE IWA_WebService FROM IWA_WebService, deleted
  WHERE IWA_WebService.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalNamingAndDirectory FROM IWA_ExternalNamingAndDirectory, deleted
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalDatabase FROM IWA_ExternalDatabase, deleted
  WHERE IWA_ExternalDatabase.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_User FROM IWA_User, deleted
  WHERE IWA_User.ApplicationId = deleted.ApplicationId

  DELETE IWA_SignalEvent FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.ApplicationId = deleted.ApplicationId

  DELETE IWA_ContentManagementSystem FROM IWA_ContentManagementSystem, deleted
  WHERE IWA_ContentManagementSystem.ApplicationId = deleted.ApplicationId

  DELETE IWA_RestClient FROM IWA_RestClient, deleted
  WHERE IWA_RestClient.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityDescriptor FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = deleted.SecurityDescriptorId


GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=38
GO
