# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 35 to version 36
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# ivyTeam AG, Alpenstrasse 9, 6304 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskDeleteTrigger;

# Create new added tables
CREATE TABLE IWA_TaskSignalEventReceiver
(
  TaskSignalEventId BIGINT NOT NULL,
  WaitingTaskId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  SignaledTaskTaskStartId BIGINT NOT NULL,
  StartedSignaledTaskId BIGINT,
  PRIMARY KEY (TaskSignalEventId),
  FOREIGN KEY (SignaledTaskTaskStartId) REFERENCES IWA_TaskStart(TaskStartId) ON DELETE CASCADE,
  INDEX IWA_TskSigEvntRcvr_WtingTaskId (WaitingTaskId),
  INDEX IWA_TskSigEvntRcvr_StrtSgTskId (StartedSignaledTaskId)
) ENGINE=InnoDB;

CREATE TABLE IWA_SignaledTask
(
  SignaledTaskId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  ReceivedSignalEventId BIGINT,
  PRIMARY KEY (SignaledTaskId),
  INDEX IWA_SigTask_RecvdSignalEventId (ReceivedSignalEventId)
) ENGINE=InnoDB;

CREATE TABLE IWA_SignalEvent
(
  SignalEventId BIGINT NOT NULL,
  ApplicationId BIGINT NOT NULL,
  SignalCode VARCHAR(200) NOT NULL,
  SentTimestamp DATETIME NOT NULL,
  SentByUserName VARCHAR(200),
  SentByUserId BIGINT,
  SentByTaskId BIGINT,
  SentByProcessElementPid VARCHAR(200),
  PRIMARY KEY (SignalEventId),
  INDEX IWA_SignalEvent_SignalCode (SignalCode),
  INDEX IWA_SignalEvent_SentTimestamp (SentTimestamp),
  INDEX IWA_SignalEvent_SentByTaskId (SentByTaskId),
  INDEX IWA_SignalEvent_SentByUserId (SentByUserId)
) ENGINE=InnoDB;

CREATE TABLE IWA_SignalEventData
(
  SignalEventId BIGINT NOT NULL,
  SignalData MEDIUMBLOB NOT NULL,
  PRIMARY KEY (SignalEventId)
) ENGINE=InnoDB;

CREATE TABLE IWA_StartSignalEventElement
(
  TaskStartId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  PRIMARY KEY (TaskStartId),
  INDEX IWA_StrtSigEvntElmnt_SgCdPttrn (SignalCodePattern)
) ENGINE=InnoDB;


# Create trigger which depend on new added table
CREATE TRIGGER IWA_SignaledTaskDeleteTrigger
AFTER DELETE ON IWA_SignaledTask
FOR EACH ROW
BEGIN
  UPDATE IWA_TaskSignalEventReceiver
  SET StartedSignaledTaskId=NULL
  WHERE IWA_TaskSignalEventReceiver.StartedSignaledTaskId=OLD.SignaledTaskId;

END
;


# Create trigger which depend on new added table
CREATE TRIGGER IWA_SignalEventDeleteTrigger
AFTER DELETE ON IWA_SignalEvent
FOR EACH ROW
BEGIN
  UPDATE IWA_SignaledTask
  SET ReceivedSignalEventId=NULL
  WHERE IWA_SignaledTask.ReceivedSignalEventId=OLD.SignalEventId;

  DELETE FROM IWA_SignalEventData
  WHERE IWA_SignalEventData.SignalEventId = OLD.SignalEventId;

END
;


# Changed columns of table IWA_Library
ALTER TABLE IWA_Library MODIFY
  Version VARCHAR(50) NOT NULL DEFAULT '';


# Changed columns of table IWA_LibraryVersionSpec
ALTER TABLE IWA_LibraryVersionSpec MODIFY
  Version VARCHAR(50) NOT NULL DEFAULT '';


# Create new indexes of table IWA_UserLocation
CREATE INDEX IWA_UserLocation_UserId
ON IWA_UserLocation (UserId);


# Create new indexes of table IWA_TaskLocation
CREATE INDEX IWA_TaskLocation_TaskId
ON IWA_TaskLocation (TaskId);


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_ApplicationProperty
  WHERE IWA_ApplicationProperty.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Environment
  WHERE IWA_Environment.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_GlobalVariable
  WHERE IWA_GlobalVariable.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalNamingAndDirectory
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalDatabase
  WHERE IWA_ExternalDatabase.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ContentManagementSystem
  WHERE IWA_ContentManagementSystem.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
AFTER DELETE ON IWA_User
FOR EACH ROW
BEGIN
  UPDATE IWA_Task
  SET State=9, FailedTimeoutTimestamp=NULL, WorkerUserId=NULL, WorkerUserName=NULL
  WHERE ((IWA_Task.ActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=0) OR (IWA_Task.ExpiryActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=1)) AND (IWA_Task.State=3 OR IWA_Task.State=4 OR IWA_Task.State=8 OR IWA_Task.State=10);

  UPDATE IWA_Task
  SET State=4, WorkerUserName=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId AND IWA_Task.State=8;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.UserId = OLD.UserId;

  DELETE FROM IWA_UserProperty
  WHERE IWA_UserProperty.UserId = OLD.UserId;

  DELETE FROM IWA_RichDialogUserContext
  WHERE IWA_RichDialogUserContext.UserId = OLD.UserId;

  DELETE FROM IWA_UserAbsence
  WHERE IWA_UserAbsence.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteUserId = OLD.UserId;

  UPDATE IWA_StartElement
  SET ActivatorUserId=NULL
  WHERE IWA_StartElement.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Case
  SET CreatorUserId=NULL
  WHERE IWA_Case.CreatorUserId=OLD.UserId;

  UPDATE IWA_Task
  SET WorkerUserId=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ActivatorUserId=NULL
  WHERE IWA_Task.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ExpiryActivatorUserId=NULL
  WHERE IWA_Task.ExpiryActivatorUserId=OLD.UserId;

  UPDATE IWA_WorkflowEvent
  SET UserId=NULL
  WHERE IWA_WorkflowEvent.UserId=OLD.UserId;

  UPDATE IWA_Note
  SET UserId=NULL
  WHERE IWA_Note.UserId=OLD.UserId;

  DELETE FROM IWA_UserLocation
  WHERE IWA_UserLocation.UserId = OLD.UserId;

  UPDATE IWA_SignalEvent
  SET SentByUserId=NULL
  WHERE IWA_SignalEvent.SentByUserId=OLD.UserId;

  UPDATE IWA_PageArchive
  SET UserId=NULL
  WHERE IWA_PageArchive.UserId=OLD.UserId;

  UPDATE IWA_SecurityDescriptor
  SET OwnerUserId=NULL
  WHERE IWA_SecurityDescriptor.OwnerUserId=OLD.UserId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.UserId = OLD.UserId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
AFTER DELETE ON IWA_TaskStart
FOR EACH ROW
BEGIN
  DELETE FROM IWA_StartElement
  WHERE IWA_StartElement.TaskStartId = OLD.TaskStartId;

  DELETE FROM IWA_StartEventElement
  WHERE IWA_StartEventElement.TaskStartId = OLD.TaskStartId;

  DELETE FROM IWA_WebServiceProcStartElement
  WHERE IWA_WebServiceProcStartElement.TaskStartId = OLD.TaskStartId;

  DELETE FROM IWA_IntermediateEventElement
  WHERE IWA_IntermediateEventElement.TaskStartId = OLD.TaskStartId;

  DELETE FROM IWA_StartSignalEventElement
  WHERE IWA_StartSignalEventElement.TaskStartId = OLD.TaskStartId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskDeleteTrigger
AFTER DELETE ON IWA_Task
FOR EACH ROW
BEGIN
  DELETE FROM IWA_TaskData
  WHERE IWA_TaskData.TaskId = OLD.TaskId;

  DELETE FROM IWA_WorkflowEvent
  WHERE IWA_WorkflowEvent.TaskId = OLD.TaskId;

  DELETE FROM IWA_IntermediateEvent
  WHERE IWA_IntermediateEvent.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskNote
  WHERE IWA_TaskNote.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskAdditionalProperty
  WHERE IWA_TaskAdditionalProperty.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskLocation
  WHERE IWA_TaskLocation.TaskId = OLD.TaskId;

  DELETE FROM IWA_TaskSignalEventReceiver
  WHERE IWA_TaskSignalEventReceiver.WaitingTaskId = OLD.TaskId;

  DELETE FROM IWA_SignaledTask
  WHERE IWA_SignaledTask.SignaledTaskId = OLD.TaskId;

  UPDATE IWA_SignalEvent
  SET SentByTaskId=NULL
  WHERE IWA_SignalEvent.SentByTaskId=OLD.TaskId;

  DELETE FROM IWA_PageArchive
  WHERE IWA_PageArchive.TaskId = OLD.TaskId;

END
;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=36;
