# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 38 to version 39
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Drop trigger of no longer exisiting table
DROP TRIGGER IWA_RestClientDeleteTrigger;

# Drop no longer exisiting table
DROP TABLE IWA_RestClientProperty;

# Drop no longer exisiting table
DROP TABLE IWA_RestClientFeature;

# Drop no longer exisiting table
DROP TABLE IWA_RestClient;

# Create new added tables
CREATE TABLE IWA_RestServiceClient
(
  RestClientId BIGINT NOT NULL,
  ParentRestClientId BIGINT,
  UUID VARCHAR(36) NOT NULL,
  ApplicationId BIGINT NOT NULL,
  EnvironmentId BIGINT,
  Name VARCHAR(200) NOT NULL,
  Description VARCHAR(2000) NOT NULL,
  URI VARCHAR(1024),
  PRIMARY KEY (RestClientId),
  FOREIGN KEY (EnvironmentId) REFERENCES IWA_Environment(EnvironmentId) ON DELETE CASCADE,
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, UUID),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, Name)
) ENGINE=InnoDB;

CREATE TABLE IWA_RestServiceClientProperty
(
  RestClientPropertyId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` VARCHAR(1024) NOT NULL,
  IsPassword BIT NOT NULL,
  PRIMARY KEY (RestClientPropertyId),
  FOREIGN KEY (RestClientId) REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE
) ENGINE=InnoDB;

CREATE TABLE IWA_RestServiceClientFeature
(
  RestClientFeatureId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId),
  FOREIGN KEY (RestClientId) REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE
) ENGINE=InnoDB;

ALTER TABLE IWA_RestServiceClient ADD
(
 FOREIGN KEY (ParentRestClientId) REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE
);


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_ApplicationProperty
  WHERE IWA_ApplicationProperty.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Environment
  WHERE IWA_Environment.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_GlobalVariable
  WHERE IWA_GlobalVariable.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalNamingAndDirectory
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalDatabase
  WHERE IWA_ExternalDatabase.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ContentManagementSystem
  WHERE IWA_ContentManagementSystem.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_RestServiceClient
  WHERE IWA_RestServiceClient.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=39;
