# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 48 to version 49
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------

# Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_CaseQuery;


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentManagementSystemDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentObjectDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ContentObjectValueDeleteTrigger;

# Drop no longer exisiting table
DROP TABLE IWA_ProcessModelVersionRole;

# Drop no longer exisiting table
DROP TABLE IWA_StartPage;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataInteger;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataFloat;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataDateTime;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataDecimal;

# Added columns of table IWA_Case
ALTER TABLE IWA_Case ADD COLUMN
  OwnerRoleId BIGINT;
ALTER TABLE IWA_Case ADD COLUMN
  OwnerUserId BIGINT;
ALTER TABLE IWA_Case ADD COLUMN
  OwnerName VARCHAR(200);

# Create new indexes of table IWA_Case
CREATE INDEX IWA_Case_OwnerRoleIdIndex
ON IWA_Case (OwnerRoleId);

CREATE INDEX IWA_Case_OwnerUserIdIndex
ON IWA_Case (OwnerUserId);


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
AFTER DELETE ON IWA_ProcessModelVersion
FOR EACH ROW
BEGIN
  DELETE FROM IWA_PageElement
  WHERE IWA_PageElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_TaskElement
  WHERE IWA_TaskElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_WebServiceProcess
  WHERE IWA_WebServiceProcess.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_ContentManagementSystem
  WHERE IWA_ContentManagementSystem.ProcessModelVersionId = OLD.ProcessModelVersionId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
AFTER DELETE ON IWA_Role
FOR EACH ROW
BEGIN
  UPDATE IWA_Task
  SET State=9, FailedTimeoutTimestamp=NULL, WorkerUserId=NULL, WorkerUserName=NULL
  WHERE ((IWA_Task.ActivatorRoleId=OLD.RoleId AND IWA_Task.IsExpired=0) OR (IWA_Task.ExpiryActivatorRoleId=OLD.RoleId AND IWA_Task.IsExpired=1)) AND (IWA_Task.State=3 OR IWA_Task.State=4 OR IWA_Task.State=8 OR IWA_Task.State=10);

  DELETE FROM IWA_RoleProperty
  WHERE IWA_RoleProperty.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleMemberId = OLD.RoleId;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.RoleId = OLD.RoleId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteForRoleId = OLD.RoleId;

  UPDATE IWA_StartElement
  SET ActivatorRoleId=NULL
  WHERE IWA_StartElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_StartEventElement
  SET ActivatorRoleId=NULL
  WHERE IWA_StartEventElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_WebServiceProcStartElement
  SET ActivatorRoleId=NULL
  WHERE IWA_WebServiceProcStartElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_Case
  SET OwnerRoleId=NULL
  WHERE IWA_Case.OwnerRoleId=OLD.RoleId;

  UPDATE IWA_Task
  SET ActivatorRoleId=NULL
  WHERE IWA_Task.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_Task
  SET ExpiryActivatorRoleId=NULL
  WHERE IWA_Task.ExpiryActivatorRoleId=OLD.RoleId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.RoleId = OLD.RoleId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
AFTER DELETE ON IWA_User
FOR EACH ROW
BEGIN
  UPDATE IWA_Task
  SET State=9, FailedTimeoutTimestamp=NULL, WorkerUserId=NULL, WorkerUserName=NULL
  WHERE ((IWA_Task.ActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=0) OR (IWA_Task.ExpiryActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=1)) AND (IWA_Task.State=3 OR IWA_Task.State=4 OR IWA_Task.State=8 OR IWA_Task.State=10);

  UPDATE IWA_Task
  SET State=4, WorkerUserName=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId AND IWA_Task.State=8;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.UserId = OLD.UserId;

  DELETE FROM IWA_UserProperty
  WHERE IWA_UserProperty.UserId = OLD.UserId;

  DELETE FROM IWA_RichDialogUserContext
  WHERE IWA_RichDialogUserContext.UserId = OLD.UserId;

  DELETE FROM IWA_UserAbsence
  WHERE IWA_UserAbsence.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteUserId = OLD.UserId;

  UPDATE IWA_StartElement
  SET ActivatorUserId=NULL
  WHERE IWA_StartElement.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Case
  SET CreatorUserId=NULL
  WHERE IWA_Case.CreatorUserId=OLD.UserId;

  UPDATE IWA_Case
  SET OwnerUserId=NULL
  WHERE IWA_Case.OwnerUserId=OLD.UserId;

  UPDATE IWA_Task
  SET WorkerUserId=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ActivatorUserId=NULL
  WHERE IWA_Task.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ExpiryActivatorUserId=NULL
  WHERE IWA_Task.ExpiryActivatorUserId=OLD.UserId;

  UPDATE IWA_WorkflowEvent
  SET UserId=NULL
  WHERE IWA_WorkflowEvent.UserId=OLD.UserId;

  UPDATE IWA_Note
  SET UserId=NULL
  WHERE IWA_Note.UserId=OLD.UserId;

  DELETE FROM IWA_UserLocation
  WHERE IWA_UserLocation.UserId = OLD.UserId;

  UPDATE IWA_SignalEvent
  SET SentByUserId=NULL
  WHERE IWA_SignalEvent.SentByUserId=OLD.UserId;

  UPDATE IWA_PageArchive
  SET UserId=NULL
  WHERE IWA_PageArchive.UserId=OLD.UserId;

  UPDATE IWA_SecurityDescriptor
  SET OwnerUserId=NULL
  WHERE IWA_SecurityDescriptor.OwnerUserId=OLD.UserId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.UserId = OLD.UserId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentManagementSystemDeleteTrigger
AFTER DELETE ON IWA_ContentManagementSystem
FOR EACH ROW
BEGIN
  DELETE FROM IWA_SupportedLanguage
  WHERE IWA_SupportedLanguage.ContentManagementSystemId = OLD.ContentManagementSystemId;

  DELETE FROM IWA_ContentObject
  WHERE IWA_ContentObject.ContentManagementSystemId = OLD.ContentManagementSystemId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentObjectDeleteTrigger
AFTER DELETE ON IWA_ContentObject
FOR EACH ROW
BEGIN
  UPDATE IWA_ContentManagementSystem
  SET DefaultPageLayoutId=NULL
  WHERE IWA_ContentManagementSystem.DefaultPageLayoutId=OLD.ContentObjectId;

  UPDATE IWA_ContentManagementSystem
  SET DefaultPageStyleSheetId=NULL
  WHERE IWA_ContentManagementSystem.DefaultPageStyleSheetId=OLD.ContentObjectId;

  DELETE FROM IWA_ContentObjectValue
  WHERE IWA_ContentObjectValue.ContentObjectId = OLD.ContentObjectId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ContentObjectValueDeleteTrigger
AFTER DELETE ON IWA_ContentObjectValue
FOR EACH ROW
BEGIN
  DELETE FROM IWA_ContentDataString
  WHERE IWA_ContentDataString.ContentObjectValueId = OLD.ContentObjectValueId;

  DELETE FROM IWA_ContentDataText
  WHERE IWA_ContentDataText.ContentObjectValueId = OLD.ContentObjectValueId;

  DELETE FROM IWA_ContentDataImage
  WHERE IWA_ContentDataImage.ContentObjectValueId = OLD.ContentObjectValueId;

END
;


# Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  `State`,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  BusinessCaseId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    CASE WHEN WorkerUserId IS NOT NULL AND LENGTH(WorkerUser.FullName) > 0 THEN WorkerUser.FullName WHEN WorkerUserId IS NOT NULL THEN WorkerUser.Name ELSE NULL END,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    CASE WHEN IWA_Task.ActivatorUserId IS NOT NULL AND LENGTH(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.ActivatorRoleId IS NOT NULL AND LENGTH(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    CASE WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LENGTH(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LENGTH(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.`State`,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LENGTH(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LENGTH(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND LENGTH(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL AND LENGTH(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.BusinessCaseId,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task
    INNER JOIN IWA_Case ON IWA_Task.CaseId = IWA_Case.CaseId
    LEFT OUTER JOIN IWA_User AS ActivatorUser ON IWA_Task.ActivatorUserId = ActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ActivatorRole ON IWA_Task.ActivatorRoleId = ActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS ExpiryActivatorUser ON IWA_Task.ExpiryActivatorUserId = ExpiryActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ExpiryActivatorRole ON IWA_Task.ExpiryActivatorRoleId = ExpiryActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS WorkerUser ON IWA_Task.WorkerUserId = WorkerUser.UserId;

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  `State`,
  Priority,
  Stage,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessStartTimestamp,
  BusinessMilestoneTimestamp,
  BusinessPriority,
  BusinessCreatorUser,
  BusinessMainContactType,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessMainContactDocDbCode,
  BusinessMainContactFolderId,
  BusinessCorrespondentId,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessObjectDocDbCode,
  BusinessObjectFolderId,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorUserId,
    IWA_Case.CreatorUserName,
    CASE WHEN IWA_Case.CreatorUserId IS NOT NULL AND LENGTH(IWA_User.FullName) > 0 THEN IWA_User.FullName WHEN IWA_Case.CreatorUserId IS NOT NULL THEN IWA_User.Name ELSE NULL END,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendarId,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case.`State`,
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    IWA_Case.OwnerName,
    IWA_Case.Category,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessMilestoneTimestamp,
    IWA_Case.BusinessPriority,
    IWA_Case.BusinessCreatorUser,
    IWA_Case.BusinessMainContactType,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessMainContactDocDbCode,
    IWA_Case.BusinessMainContactFolderId,
    IWA_Case.BusinessCorrespondentId,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessObjectDocDbCode,
    IWA_Case.BusinessObjectFolderId,
    IWA_Case.CustomVarCharField1,
    IWA_Case.CustomVarCharField2,
    IWA_Case.CustomVarCharField3,
    IWA_Case.CustomVarCharField4,
    IWA_Case.CustomVarCharField5,
    IWA_Case.CustomDecimalField1,
    IWA_Case.CustomDecimalField2,
    IWA_Case.CustomDecimalField3,
    IWA_Case.CustomDecimalField4,
    IWA_Case.CustomDecimalField5,
    IWA_Case.CustomTimestampField1,
    IWA_Case.CustomTimestampField2,
    IWA_Case.CustomTimestampField3,
    IWA_Case.CustomTimestampField4,
    IWA_Case.CustomTimestampField5
  FROM IWA_Case
    LEFT OUTER JOIN IWA_User ON IWA_Case.CreatorUserId = IWA_User.UserId;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=49;
