# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 50 to version 51
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger;

# Drop no longer exisiting table
DROP TABLE IWA_RichDialogUserContext;

# Create new added tables
CREATE TABLE IWA_TaskCustomStringField
(
  TaskCustomStringFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` VARCHAR(2000) NOT NULL,
  PRIMARY KEY (TaskCustomStringFieldId),
  FOREIGN KEY (TaskId) REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  UNIQUE (TaskId, Name),
  INDEX IWA_TaskCstmStringFldValueIdx (`Value`(255))
) ENGINE=InnoDB;

CREATE TABLE IWA_TaskCustomTextField
(
  TaskCustomTextFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` TEXT NOT NULL,
  PRIMARY KEY (TaskCustomTextFieldId),
  FOREIGN KEY (TaskId) REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  UNIQUE (TaskId, Name)
) ENGINE=InnoDB;

CREATE TABLE IWA_TaskCustomNumberField
(
  TaskCustomNumberFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (TaskCustomNumberFieldId),
  FOREIGN KEY (TaskId) REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  UNIQUE (TaskId, Name),
  INDEX IWA_TaskCstmNumberFldValueIdx (`Value`)
) ENGINE=InnoDB;

CREATE TABLE IWA_TaskCustomTimestampField
(
  TaskCustomTimestampFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` DATETIME NOT NULL,
  PRIMARY KEY (TaskCustomTimestampFieldId),
  FOREIGN KEY (TaskId) REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  UNIQUE (TaskId, Name),
  INDEX IWA_TaskCstmTmstmpFldValIdx (`Value`)
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseCustomStringField
(
  CaseCustomStringFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` VARCHAR(2000) NOT NULL,
  PRIMARY KEY (CaseCustomStringFieldId),
  FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (CaseId, Name),
  INDEX IWA_CaseCstmStringFldValueIdx (`Value`(255))
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseCustomTextField
(
  CaseCustomTextFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` TEXT NOT NULL,
  PRIMARY KEY (CaseCustomTextFieldId),
  FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (CaseId, Name)
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseCustomNumberField
(
  CaseCustomNumberFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (CaseCustomNumberFieldId),
  FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (CaseId, Name),
  INDEX IWA_CaseCstmNubmerFldValueIdx (`Value`)
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseCustomTimestampField
(
  CaseCustomTimestampFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` DATETIME NOT NULL,
  PRIMARY KEY (CaseCustomTimestampFieldId),
  FOREIGN KEY (CaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (CaseId, Name),
  INDEX IWA_CaseCstmTmstmpFldValIdx (`Value`)
) ENGINE=InnoDB;


# Added columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ADD COLUMN
  SubstitutionType INTEGER NOT NULL DEFAULT 0;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
AFTER DELETE ON IWA_User
FOR EACH ROW
BEGIN
  UPDATE IWA_Task
  SET State=9, FailedTimeoutTimestamp=NULL, WorkerUserId=NULL, WorkerUserName=NULL
  WHERE ((IWA_Task.ActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=0) OR (IWA_Task.ExpiryActivatorUserId=OLD.UserId AND IWA_Task.IsExpired=1)) AND (IWA_Task.State=3 OR IWA_Task.State=4 OR IWA_Task.State=8 OR IWA_Task.State=10);

  UPDATE IWA_Task
  SET State=4, WorkerUserName=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId AND IWA_Task.State=8;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.UserId = OLD.UserId;

  DELETE FROM IWA_UserProperty
  WHERE IWA_UserProperty.UserId = OLD.UserId;

  DELETE FROM IWA_UserAbsence
  WHERE IWA_UserAbsence.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.UserId = OLD.UserId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteUserId = OLD.UserId;

  UPDATE IWA_StartElement
  SET ActivatorUserId=NULL
  WHERE IWA_StartElement.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Case
  SET CreatorUserId=NULL
  WHERE IWA_Case.CreatorUserId=OLD.UserId;

  UPDATE IWA_Case
  SET OwnerUserId=NULL
  WHERE IWA_Case.OwnerUserId=OLD.UserId;

  UPDATE IWA_Task
  SET WorkerUserId=NULL
  WHERE IWA_Task.WorkerUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ActivatorUserId=NULL
  WHERE IWA_Task.ActivatorUserId=OLD.UserId;

  UPDATE IWA_Task
  SET ExpiryActivatorUserId=NULL
  WHERE IWA_Task.ExpiryActivatorUserId=OLD.UserId;

  UPDATE IWA_WorkflowEvent
  SET UserId=NULL
  WHERE IWA_WorkflowEvent.UserId=OLD.UserId;

  UPDATE IWA_Note
  SET UserId=NULL
  WHERE IWA_Note.UserId=OLD.UserId;

  DELETE FROM IWA_UserLocation
  WHERE IWA_UserLocation.UserId = OLD.UserId;

  UPDATE IWA_SignalEvent
  SET SentByUserId=NULL
  WHERE IWA_SignalEvent.SentByUserId=OLD.UserId;

  UPDATE IWA_PageArchive
  SET UserId=NULL
  WHERE IWA_PageArchive.UserId=OLD.UserId;

  UPDATE IWA_SecurityDescriptor
  SET OwnerUserId=NULL
  WHERE IWA_SecurityDescriptor.OwnerUserId=OLD.UserId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.UserId = OLD.UserId;

END
;


# Create added views
CREATE VIEW IWA_TaskCustomField
(
  TaskId,
  Name,
  `Type`,
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.TaskId,
    StringField.Name,
    'String',
    StringField.`Value`,
    NULL,
    NULL,
    NULL
  FROM IWA_TaskCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.TaskId,
    TextField.Name,
    'Text',
    NULL,
    TextField.`Value`,
    NULL,
    NULL
  FROM IWA_TaskCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.TaskId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField.`Value`,
    NULL
  FROM IWA_TaskCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.TaskId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField.`Value`
  FROM IWA_TaskCustomTimestampField AS TimestampField;

CREATE VIEW IWA_CaseCustomField
(
  CaseId,
  Name,
  `Type`,
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.CaseId,
    StringField.Name,
    'String',
    StringField.`Value`,
    NULL,
    NULL,
    NULL
  FROM IWA_CaseCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.CaseId,
    TextField.Name,
    'Text',
    NULL,
    TextField.`Value`,
    NULL,
    NULL
  FROM IWA_CaseCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.CaseId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField.`Value`,
    NULL
  FROM IWA_CaseCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.CaseId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField.`Value`
  FROM IWA_CaseCustomTimestampField AS TimestampField;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=51;
