-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 43 to version 44
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery;


-- Added columns of table IWA_StartSignalEventElement
ALTER TABLE IWA_StartSignalEventElement ADD
  AttachToBusinessCase NUMBER(1) DEFAULT 0 NOT NULL;

-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  State,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  BusinessCaseId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.State,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.BusinessCaseId,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task, IWA_Case
  WHERE IWA_Task.CaseId = IWA_Case.CaseId;

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=44;
