-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 50 to version 51
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop no longer exisiting table
DROP TABLE IWA_RichDialogUserContext;

-- Create new added tables
CREATE TABLE IWA_TaskCustomStringField
(
  TaskCustomStringFieldId NUMBER(20) NOT NULL,
  TaskId NUMBER(20) NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" VARCHAR2(2000) NOT NULL,
  PRIMARY KEY (TaskCustomStringFieldId),
  UNIQUE (TaskId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_TaskCstmStringFldValueIdx
ON IWA_TaskCustomStringField ("VALUE")
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_TaskCustomTextField
(
  TaskCustomTextFieldId NUMBER(20) NOT NULL,
  TaskId NUMBER(20) NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" CLOB NOT NULL,
  PRIMARY KEY (TaskCustomTextFieldId),
  UNIQUE (TaskId, Name)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_TaskCustomNumberField
(
  TaskCustomNumberFieldId NUMBER(20) NOT NULL,
  TaskId NUMBER(20) NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (TaskCustomNumberFieldId),
  UNIQUE (TaskId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_TaskCstmNumberFldValueIdx
ON IWA_TaskCustomNumberField ("VALUE")
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_TaskCustomTimestampField
(
  TaskCustomTimestampFieldId NUMBER(20) NOT NULL,
  TaskId NUMBER(20) NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" DATE NOT NULL,
  PRIMARY KEY (TaskCustomTimestampFieldId),
  UNIQUE (TaskId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_TaskCstmTmstmpFldValIdx
ON IWA_TaskCustomTimestampField ("VALUE")
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseCustomStringField
(
  CaseCustomStringFieldId NUMBER(20) NOT NULL,
  CaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" VARCHAR2(2000) NOT NULL,
  PRIMARY KEY (CaseCustomStringFieldId),
  UNIQUE (CaseId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseCstmStringFldValueIdx
ON IWA_CaseCustomStringField ("VALUE")
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseCustomTextField
(
  CaseCustomTextFieldId NUMBER(20) NOT NULL,
  CaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" CLOB NOT NULL,
  PRIMARY KEY (CaseCustomTextFieldId),
  UNIQUE (CaseId, Name)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseCustomNumberField
(
  CaseCustomNumberFieldId NUMBER(20) NOT NULL,
  CaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (CaseCustomNumberFieldId),
  UNIQUE (CaseId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseCstmNubmerFldValueIdx
ON IWA_CaseCustomNumberField ("VALUE")
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_CaseCustomTimestampField
(
  CaseCustomTimestampFieldId NUMBER(20) NOT NULL,
  CaseId NUMBER(20) NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" DATE NOT NULL,
  PRIMARY KEY (CaseCustomTimestampFieldId),
  UNIQUE (CaseId, Name)
)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_CaseCstmTmstmpFldValIdx
ON IWA_CaseCustomTimestampField ("VALUE")
TABLESPACE ${tablespaceName};


-- Added columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ADD
  SubstitutionType NUMBER(10) DEFAULT 0 NOT NULL;

-- Create added views
CREATE VIEW IWA_TaskCustomField
(
  TaskId,
  Name,
  "TYPE",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.TaskId,
    StringField.Name,
    'String',
    StringField."VALUE",
    NULL,
    NULL,
    NULL
  FROM IWA_TaskCustomStringField StringField
UNION ALL
  SELECT
    TextField.TaskId,
    TextField.Name,
    'Text',
    NULL,
    TextField."VALUE",
    NULL,
    NULL
  FROM IWA_TaskCustomTextField TextField
UNION ALL
  SELECT
    NumberField.TaskId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField."VALUE",
    NULL
  FROM IWA_TaskCustomNumberField NumberField
UNION ALL
  SELECT
    TimestampField.TaskId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField."VALUE"
  FROM IWA_TaskCustomTimestampField TimestampField;

CREATE VIEW IWA_CaseCustomField
(
  CaseId,
  Name,
  "TYPE",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.CaseId,
    StringField.Name,
    'String',
    StringField."VALUE",
    NULL,
    NULL,
    NULL
  FROM IWA_CaseCustomStringField StringField
UNION ALL
  SELECT
    TextField.CaseId,
    TextField.Name,
    'Text',
    NULL,
    TextField."VALUE",
    NULL,
    NULL
  FROM IWA_CaseCustomTextField TextField
UNION ALL
  SELECT
    NumberField.CaseId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField."VALUE",
    NULL
  FROM IWA_CaseCustomNumberField NumberField
UNION ALL
  SELECT
    TimestampField.CaseId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField."VALUE"
  FROM IWA_CaseCustomTimestampField TimestampField;

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=51;
