-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 56 to version 57
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Migrate column ProcessCategoryCode of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'ProcessCategoryCode',
      ProcessCategoryCode
    FROM IWA_Case
    WHERE ProcessCategoryCode IS NOT NULL;
  END;
$$ ;

-- Migrate column ProcessCategoryName of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'ProcessCategoryName',
      ProcessCategoryName
    FROM IWA_Case
    WHERE ProcessCategoryName IS NOT NULL;
  END;
$$ ;

-- Migrate column ProcessCode of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'ProcessCode',
      ProcessCode
    FROM IWA_Case
    WHERE ProcessCode IS NOT NULL;
  END;
$$ ;

-- Migrate column ProcessName of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'ProcessName',
      ProcessName
    FROM IWA_Case
    WHERE ProcessName IS NOT NULL;
  END;
$$ ;

-- Migrate column TypeCode of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'TypeCode',
      TypeCode
    FROM IWA_Case
    WHERE TypeCode IS NOT NULL;
  END;
$$ ;

-- Migrate column TypeName of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'TypeName',
      TypeName
    FROM IWA_Case
    WHERE TypeName IS NOT NULL;
  END;
$$ ;

-- Migrate column SubTypeCode of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'SubTypeCode',
      SubTypeCode
    FROM IWA_Case
    WHERE SubTypeCode IS NOT NULL;
  END;
$$ ;

-- Migrate column SubTypeName of case to case custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(CaseCustomStringFieldId), 0) INTO MAX_ID FROM IWA_CaseCustomStringField;

    INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "Value")
    SELECT
      MAX_ID + 1 + CaseId,
      CaseId,
      'SubTypeName',
      SubTypeName
    FROM IWA_Case
    WHERE SubTypeName IS NOT NULL;
  END;
$$ ;

-- Migrate column KindCode of task to task custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(TaskCustomStringFieldId), 0) INTO MAX_ID FROM IWA_TaskCustomStringField;

    INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "Value")
    SELECT
      MAX_ID + 1 + TaskId,
      TaskId,
      'KindCode',
      KindCode
    FROM IWA_Task
    WHERE KindCode IS NOT NULL;
  END;
$$ ;

-- Migrate column KindName of task to task custom string fields
DO $$
  DECLARE MAX_ID BIGINT;

  BEGIN
    SELECT COALESCE(MAX(TaskCustomStringFieldId), 0) INTO MAX_ID FROM IWA_TaskCustomStringField;

    INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "Value")
    SELECT
      MAX_ID + 1 + TaskId,
      TaskId,
      'KindName',
      KindName
    FROM IWA_Task
    WHERE KindName IS NOT NULL;
  END;
$$ ;

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery;

DROP VIEW IWA_CaseQuery;


-- Drop removed indexes of table IWA_Case
DROP INDEX IWA_Case_ProcessCategoryCode;
DROP INDEX IWA_Case_ProcessCode;
DROP INDEX IWA_Case_TypeCode;
DROP INDEX IWA_Case_SubTypeCode;

-- Drop removed indexes of table IWA_Task
DROP INDEX IWA_Task_KindCodeIndex;

-- Dropped columns of table IWA_Case
ALTER TABLE IWA_Case DROP COLUMN ProcessCategoryCode;

ALTER TABLE IWA_Case DROP COLUMN ProcessCategoryName;

ALTER TABLE IWA_Case DROP COLUMN ProcessCode;

ALTER TABLE IWA_Case DROP COLUMN ProcessName;

ALTER TABLE IWA_Case DROP COLUMN TypeCode;

ALTER TABLE IWA_Case DROP COLUMN TypeName;

ALTER TABLE IWA_Case DROP COLUMN SubTypeCode;

ALTER TABLE IWA_Case DROP COLUMN SubTypeName;


-- Dropped columns of table IWA_Task
ALTER TABLE IWA_Task DROP COLUMN KindCode;

ALTER TABLE IWA_Task DROP COLUMN KindName;


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  BusinessCaseId
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    CASE WHEN WorkerUserId IS NOT NULL AND LENGTH(WorkerUser.FullName) > 0 THEN WorkerUser.FullName WHEN WorkerUserId IS NOT NULL THEN WorkerUser.Name ELSE NULL END,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    CASE WHEN IWA_Task.ActivatorUserId IS NOT NULL AND LENGTH(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.ActivatorRoleId IS NOT NULL AND LENGTH(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    CASE WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LENGTH(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LENGTH(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LENGTH(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LENGTH(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND LENGTH(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL AND LENGTH(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.BusinessCaseId
  FROM IWA_Task
    INNER JOIN IWA_Case ON IWA_Task.CaseId = IWA_Case.CaseId
    LEFT OUTER JOIN IWA_User AS ActivatorUser ON IWA_Task.ActivatorUserId = ActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ActivatorRole ON IWA_Task.ActivatorRoleId = ActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS ExpiryActivatorUser ON IWA_Task.ExpiryActivatorUserId = ExpiryActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ExpiryActivatorRole ON IWA_Task.ExpiryActivatorRoleId = ExpiryActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS WorkerUser ON IWA_Task.WorkerUserId = WorkerUser.UserId;

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  "State",
  Priority,
  Stage,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorUserId,
    IWA_Case.CreatorUserName,
    CASE WHEN IWA_Case.CreatorUserId IS NOT NULL AND LENGTH(IWA_User.FullName) > 0 THEN IWA_User.FullName WHEN IWA_Case.CreatorUserId IS NOT NULL THEN IWA_User.Name ELSE NULL END,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendarId,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case."State",
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    IWA_Case.OwnerName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_User ON IWA_Case.CreatorUserId = IWA_User.UserId;

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=57;
